//+------------------------------------------------------------------+
//|                                             FX-Session Boxes.mq4 |
//|                                     Copyright  2013, Romstreets |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Romstreets"
#property link      "ethan.candle@gmx.com"

extern int    NumberOfDays = 1;        
extern string Asian="Asian Session Parameter";
extern string D_periodBegin         = "00:15";
extern string D_periodEnd           = "01:59";
extern string A_periodBegin         = "00:15";
extern string A_periodEnd           = "08:59";
extern string GAP=   "GAP Sessions Parameter";
extern string G1_periodBegin        = "00:15";
extern string G1_periodEnd          = "02:00";
extern string G2_periodBegin        = "10:00";
extern string G2_periodEnd          = "15:00";
extern string G3_periodBegin        = "18:59";
extern string G3_periodEnd          = "19:30";
extern string EU="Euro&US Sessions Parameter";
extern string L_periodBegin         = "10:00";
extern string L_periodEnd           = "14:59";
extern string U1_periodBegin        = "10:00";
extern string U1_periodEnd          = "18:59";
extern string U2_periodBegin        = "19:30";
extern string U2_periodEnd          = "23:59";
extern string Boxes=    "Session Boxes Color";
extern color  D_BoxColor     = C'43,130,82';
extern color  A_BoxColor     = C'43,130,82';
extern color  G1_BoxColor    = C'43,130,82';
extern color  G2_BoxColor    = C'43,130,82';
extern color  G3_BoxColor    = CLR_NONE;
extern color  L_BoxColor     = C'43,130,82';
extern color  U1_BoxColor    = C'43,130,82';
extern color  U2_BoxColor    = C'43,130,82';

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

void init() {
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("DBoxHL"+i,D_BoxColor);
    CreateObjects("ABoxHL"+i,A_BoxColor);
    CreateObjects("G1BoxHL"+i,G1_BoxColor);
    CreateObjects("G2BoxHL"+i,G2_BoxColor);
    CreateObjects("G3BoxHL"+i,G3_BoxColor);
    CreateObjects("LBoxHL"+i,L_BoxColor);
    CreateObjects("U1BoxHL"+i,U1_BoxColor);
    CreateObjects("U2BoxHL"+i,U2_BoxColor);
  }
  Comment("");
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

void deinit() {
   DeleteObjects();
    Comment("");
return(0);
}
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//| Remove all Rectangles                                            |
//+------------------------------------------------------------------+
void DeleteObjects() {
    //ObjectsDeleteAll(0,OBJ_RECTANGLE);     
    for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("DBoxHL"+i);
    ObjectDelete("ABoxHL"+i);
    ObjectDelete("G1BoxHL"+i);
    ObjectDelete("G2BoxHL"+i);
    ObjectDelete("G3BoxHL"+i);
    ObjectDelete("LBoxHL"+i);
    ObjectDelete("U1BoxHL"+i);
    ObjectDelete("U2BoxHL"+i);
    }
    
 return(0); 
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

void start() {
  datetime dtTradeDate=TimeCurrent();
  double factor = 0.0001;
  int    power  = 4;
  int    round  = 0;
  // If yen pair
  if (StringFind(Symbol(), "JPY", 0) > 0)
  {
    factor = 0.01;
    power  = 2;
  }
  if (Digits != 2 && Digits != 4) round = 0;
//-------------Till Here addition code 
  for (int i=0; i<NumberOfDays; i++) {
    DrawObjects(dtTradeDate, "DBoxHL" + i, D_periodBegin, A_periodEnd, D_periodEnd, D_BoxColor, 1);
    DrawObjects(dtTradeDate, "ABoxHL" + i, A_periodBegin, A_periodEnd, A_periodEnd, A_BoxColor, 1);
    DrawObjects(dtTradeDate, "G1BoxHL" + i, G1_periodBegin, A_periodEnd, G1_periodEnd, G1_BoxColor, 1);
    DrawObjects(dtTradeDate, "G2BoxHL" + i, G2_periodBegin, U1_periodEnd, G2_periodEnd, G2_BoxColor, 1);
    DrawObjects(dtTradeDate, "G3BoxHL" + i, G3_periodBegin, G3_periodEnd, G3_periodEnd, G3_BoxColor, 1);
    DrawObjects(dtTradeDate, "LBoxHL" + i, L_periodBegin, U1_periodEnd, L_periodEnd, L_BoxColor, 1);
    DrawObjects(dtTradeDate, "U1BoxHL" + i, U1_periodBegin, U1_periodEnd, U1_periodEnd, U1_BoxColor, 1);
    DrawObjects(dtTradeDate, "U2BoxHL" + i, U2_periodBegin, U2_periodEnd, U2_periodEnd, U2_BoxColor, 1);
    dtTradeDate=decrementTradeDate(dtTradeDate);
    while (TimeDayOfWeek(dtTradeDate) > 5) dtTradeDate = decrementTradeDate(dtTradeDate);
  }
}

//+------------------------------------------------------------------+
//| Create Rectangles                                                |
//+------------------------------------------------------------------+

void DrawObjects(datetime dtTradeDate, string sObjName, string sTimeBegin, string sTimeEnd, string sTimeObjEnd, color cObjColor, int iForm) {
  datetime dtTimeBegin, dtTimeEnd, dtTimeObjEnd;
  double   dPriceHigh,  dPriceLow;
  int      iBarBegin,   iBarEnd;

  dtTimeBegin = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeBegin);
  dtTimeEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeEnd);
  dtTimeObjEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeObjEnd);
      
  iBarBegin = iBarShift(NULL, 0, dtTimeBegin);
  iBarEnd = iBarShift(NULL, 0, dtTimeEnd);
  dPriceHigh = High[Highest(NULL, 0, MODE_HIGH, iBarBegin-iBarEnd, iBarEnd)];
  dPriceLow = Low [Lowest (NULL, 0, MODE_LOW , iBarBegin-iBarEnd, iBarEnd)];
 
  ObjectCreate(sObjName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
  
  ObjectSet(sObjName, OBJPROP_TIME1 , dtTimeBegin);
  ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);

//---- High-Low Rectangle
   if(iForm==1){  
      ObjectSet(sObjName, OBJPROP_PRICE1, dPriceHigh);  
      ObjectSet(sObjName, OBJPROP_PRICE2, dPriceLow);
      ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(sObjName, OBJPROP_COLOR, cObjColor);
      ObjectSet(sObjName, OBJPROP_BACK, True);
   }
  
      string sObjDesc = StringConcatenate("High: ",dPriceHigh,"  Low: ", dPriceLow);  
      ObjectSetText(sObjName, sObjDesc,10,"Calibri",Black);
}

//+------------------------------------------------------------------+
//| Decrement Date to draw objects in the past                       |
//+------------------------------------------------------------------+

datetime decrementTradeDate (datetime dtTimeDate) {
   int iTimeYear=TimeYear(dtTimeDate);
   int iTimeMonth=TimeMonth(dtTimeDate);
   int iTimeDay=TimeDay(dtTimeDate);
   int iTimeHour=TimeHour(dtTimeDate);
   int iTimeMinute=TimeMinute(dtTimeDate);

   iTimeDay--;
   if (iTimeDay==0) {
     iTimeMonth--;
     if (iTimeMonth==0) {
       iTimeYear--;
       iTimeMonth=12;
     }
    
     // Thirty days hath September...  
     if (iTimeMonth==4 || iTimeMonth==6 || iTimeMonth==9 || iTimeMonth==11) iTimeDay=30;
     // ...all the rest have thirty-one...
     if (iTimeMonth==1 || iTimeMonth==3 || iTimeMonth==5 || iTimeMonth==7 || iTimeMonth==8 || iTimeMonth==10 || iTimeMonth==12) iTimeDay=31;
     // ...except...
     if (iTimeMonth==2) if (MathMod(iTimeYear, 4)==0) iTimeDay=29; else iTimeDay=28;
   }
  return(StrToTime(iTimeYear + "." + iTimeMonth + "." + iTimeDay + " " + iTimeHour + ":" + iTimeMinute));
}


